program epskleinspady_lf
  version 8.2
  args lnf xb
  tempvar gn1 gn Gn

  quietly {
    summ $ML_y1

    kdensity `xb' if $ML_y1==1, nogr gaussian width($width) gen(`gn1') at(`xb')
    kdensity `xb', nogr gaussian width($width) gen(`gn') at(`xb')

    summ $ML_y1, meanonly
    gen double `Gn' = r(mean)*`gn1' / `gn'

    replace `Gn'=1-$eps if `Gn'>(1-$eps)
    replace `Gn'=$eps if `Gn'<$eps

    replace `lnf' = $ML_y1 * ln(`Gn') + (1-$ML_y1) * ln(1-`Gn')
    }
    
end

