program kdkleinspady_lf
    version 8.2
    args lnf xb
    tempvar gn1 gn0 Gn

    quietly {
      summ $ML_y1, meanonly
      local ybar = r(mean)
      local width = $width
      
      kdensity `xb' if $ML_y1==1, nogr gaussian g(`gn1') at(`xb') width(`width')
      kdensity `xb' if $ML_y1==0, nogr gaussian g(`gn0') at(`xb') width(`width')

      gen double `Gn' = `ybar'*`gn1' / ( `ybar'*`gn1' + (1-`ybar')*`gn0' )
      replace `lnf' = $ML_y1 * ln(`Gn') + (1-$ML_y1) * ln(1-`Gn')
      }
end 
