!* version 1.0.1  30oct2006  Marc Muendler  muendler@ucsd.edu
* adapted from: Paulo Guimaraes

program kspady_d0

  version 8.2
  args todo b lnf
  tempvar xb gn1 gn0 Gn
  mleval `xb'=`b'

  quietly {
    if "$KS_sc"!="" {
      kdensity `xb', nogr gaussian
      global KS_h=r(width)*$KS_sc
      }
    if "$KS_st"!="" {
      summ `xb'
      global KS_h=r(sd)*$KS_st
      }
    kdensity `xb' if $ML_y1==1, nogr gaussian width($KS_h) gen(`gn1') at(`xb')
    if "$KS_v"=="" { 
      kdensity `xb' if $ML_y1==0, nogr gaussian width($KS_h) gen(`gn0') at(`xb')
      summ $ML_y1, meanonly
      gen double `Gn' = r(mean)*`gn1'/(r(mean)*`gn1'+(1-r(mean))*`gn0')
      }
    else if "$KS_v"=="1" {
      kdensity `xb', nogr gaussian width($KS_h) gen(`gn0') at(`xb')
      summ $ML_y1, meanonly
      gen double `Gn' = r(mean)*`gn1'/`gn0'
      }

    mlsum `lnf' = .5 * $ML_y1*ln(`Gn'*`Gn') + .5 * (1-$ML_y1)*ln((1-`Gn')*(1-`Gn'))  // square terms to avoid numerical problems with corner probabilities
    replace KS_fit=`Gn'
    replace KS_xb=`xb'
    }

end
